package cmd

import (
	"github.com/spf13/cobra"
	"lab.libreho.st/libre.sh/docker/wrench/internal"
)

var mongoUrl = ""

var rc = &cobra.Command{
	Use:     "rocketchat",
	Aliases: []string{"rc"},
	Short:   "All Rocket.Chat subcommands",
}

var rcUser = &cobra.Command{
	Use:   "user",
	Short: "Manipulate users",
}

var rcUserPassword = &cobra.Command{
	Use:        "password",
	Aliases:    []string{"pass"},
	Short:      "Change a user password",
	Args:       cobra.ExactArgs(3),
	ArgAliases: []string{"email", "username", "password"},
	Run: func(cmd *cobra.Command, args []string) {
		client := internal.GetMongoClient(mongoUrl)
		internal.RocketChatRestAdminPass(client, args[0], args[1], args[2])
	},
}

var rcUserCount = &cobra.Command{
	Use:   "count",
	Short: "Count users",
	Run: func(cmd *cobra.Command, args []string) {
		client := internal.GetMongoClient(mongoUrl)
		active, _ := cmd.Flags().GetBool("active")
		lastLogin, _ := cmd.Flags().GetInt("last-login")
		internal.RocketChatUserCount(client, active, lastLogin)
	},
}

func init() {
	rootCmd.AddCommand(rc)
	rc.AddCommand(rcUser)
	rc.PersistentFlags().StringVar(&mongoUrl, "mongo-url", "", "mongo url")
	rcUser.AddCommand(rcUserPassword)
	rcUser.AddCommand(rcUserCount)
	rcUserCount.Flags().Bool("active", false, "Only active users")
	rcUserCount.Flags().Int("last-login", 0, "Users logged in during the last X days.")
}
